From 2847f9e9e2ebf32249bd4fb6595e190cf2c10241 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: May 02 2016 15:30:03 +0000
Subject: [PATCH 468/1001] Add a new endpoint serving and caching locally the user's avatar


---

diff --git a/hubs/app.py b/hubs/app.py
index a35dee8..2037a04 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -6,6 +6,7 @@ import os
 import flask
 import flask.json
 import munch
+import requests
 import six
 
 from flask.ext.openid import OpenID
@@ -78,6 +79,21 @@ def index():
     return flask.redirect(flask.url_for('hub', name=flask.g.auth.nickname))
 
 
+@app.route('/_avatar/<username>')
+def avatar(username):
+    favicon = os.path.join(
+        app.static_folder, 'cache', '%s.png' % username)
+    if not os.path.exists(favicon):
+        req = requests.get(hubs.utils.username2avatar(username, s=32))
+        if req:
+            with open(favicon, 'w') as stream:
+                stream.write(req.content)
+
+    return flask.redirect(
+        flask.url_for('static', filename='cache/%s.png' % username)
+    )
+
+
 @app.route('/groups')
 def groups():
     if not flask.g.auth.logged_in:

